=== doc/sphinx2/source/fig/Makefile ===
default:
		iperender -svg depot-brisbane.pdf depot-brisbane.svg
