=== debian/changelog ===
woo (1.0+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Replace python-imaging by python-pil
    Closes: #866495
  * cme
  * debhelper 10
  * Drop unneeded "Testsuite: autopkgtest"

 -- Andreas Tille <tille@debian.org>  Sun, 07 Jan 2018 09:09:50 +0100

woo (1.0+dfsg1-1) unstable; urgency=medium

  * [ae1639e] Move to vtk6, add BD for python3.
  * [1e74080] Disable autotests temporarly. (Closes: #800407)
  * [6a9fe9e] Add MathJax_local.js to Files-Excluded.
  * [8ee1c9d] Imported Upstream version 1.0+dfsg1
  * [02150d7] Fix warnings in d/copyright.

 -- Anton Gladky <gladk@debian.org>  Tue, 27 Oct 2015 19:59:36 +0100

woo (1.0-3) unstable; urgency=medium

  * [ebc5dfc] Remove all march flags. (Closes: #797092)

 -- Anton Gladky <gladk@debian.org>  Sat, 05 Sep 2015 08:15:56 +0200

woo (1.0-2) unstable; urgency=medium

  * [013b8a2] Add VCS-fields in d/control.
  * [d571495] Remove non-existing python3-imaging from Depends.
  * [728c9f9] Remove unneded Conflicts from d/control.
  * [ac8c509] Remove core2 flag. (Closes: #797092)
  * [ebbda26] Ignore quilt dir
  * [9b2d614] Do not use gold-linker. (Closes: #797094)

 -- Anton Gladky <gladk@debian.org>  Fri, 04 Sep 2015 00:38:54 +0200

woo (1.0-1) unstable; urgency=medium

  * Initial packaging. (Closes: #794710)

 -- Anton Gladky <gladk@debian.org>  Thu, 06 Aug 2015 19:02:04 +0200
