=== debian/control ===
Source: woo
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Václav Šmilauer <eu@doxos.eu>,
           Anton Gladky <gladk@debian.org>
Section: python
Priority: optional
Build-Depends: python-all,
               python-all-dev,
               python-setuptools,
               python3-setuptools,
               python3-all,
               python3-all-dev,
               debhelper (>= 10),
               libboost-all-dev,
               pyqt4-dev-tools,
               libqt4-dev,
               libqt4-dev-bin,
               qt4-dev-tools,
               libgle3-dev,
               libqglviewer-dev-qt4,
               libvtk6-dev,
               libgts-dev,
               libeigen3-dev,
               python3-minieigen,
               python-minieigen,
               freeglut3-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/woo.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/woo.git
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.4

Package: python-woo
Architecture: any
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python-xlrd,
         python-xlwt,
         python-numpy,
         python-matplotlib,
         python-colorama,
         python-qt4,
         python-xlib,
         python-genshi,
         python-psutil,
         python-minieigen,
         python3-minieigen,
         python-pil,
         python-h5py,
         python-lockfile,
         ipython,
         mencoder | libav-tools | ffmpeg,
         python-prettytable
Description: Discrete dynamic computations, esp. granular mechanics (python 2)
 Extesible and portable framework primarily for mechanics
 granular materials. Computation parts are written in c++ parallelized using
 OpenMP, fully accessible and modifiable from python (ipython console or
 scripts). Arbitrarily complex scene can be scripted. Qt-based user interface
 is provided, featuring flexible OpenGL display, inspection of all objects
 and runtime modification. Parametric preprocessors can be written in pure
 python, and batch system can be used to drive parametric studies. New
 material models and particle shapes can be added (in c++) without modifying
 existing classes.
 .
 Woo is an evolution of the Yade package
 (http://www.launchpad.net/yade), aiming at more flexibility, extensibility,
 tighter integration with python and user-friendliness.
 .
 This version is built with OpenMP enabled, and targets Python 2.x

Package: python3-woo
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         python3-xlrd,
         python3-xlsxwriter,
         python3-numpy,
         python3-matplotlib,
         python3-colorama,
         python3-pyqt4,
         python3-xlib,
         python3-genshi,
         python3-psutil,
         python3-minieigen,
         python3-pil,
         python3-h5py,
         python3-lockfile,
         ipython3,
         mencoder | libav-tools | ffmpeg,
         python3-prettytable
Description: Discrete dynamic compuations, esp. granular mechanics (python 3)
 Extesible and portable framework primarily for mechanics
 granular materials. Computation parts are written in c++ parallelized using
 OpenMP, fully accessible and modifiable from python (ipython console or
 scripts). Arbitrarily complex scene can be scripted. Qt-based user interface
 is provided, featuring flexible OpenGL display, inspection of all objects
 and runtime modification. Parametric preprocessors can be written in pure
 python, and batch system can be used to drive parametric studies. New
 material models and particle shapes can be added (in c++) without modifying
 existing classes.
 .
 Woo is an evolution of the Yade package
 (http://www.launchpad.net/yade), aiming at more flexibility, extensibility,
 tighter integration with python and user-friendliness.
 .
 This version is built with OpenMP enabled, and targets Python 3.x.
