=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export PYBUILD_NAME=woo

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

override_dh_auto_clean:

override_dh_auto_test:
