=== debian/tests/control ===
Tests: wootest
Depends: python-woo
